# V1.2, made by Patch_R, feel free to include this file at your mod...
import App
import MissionLib
import Libs.LibEngineering
import Bridge.BridgeUtils
import Custom.NanoFXv2.ExplosionFX.ExpFX
import Custom.NanoFXv2.NanoFX_ScriptActions
import Custom.NanoFXv2.NanoFX_Lib
import Foundation
from Custom.Autoload.Patch_R_Batterys import mode
pPlayer = MissionLib.GetPlayer()
pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
EnableTimer = None
pPowerTransfer = None
BCS = None
MainBatteryPower = None
poweroutold = None
ReserveBatteryPower = None
ReserveBatteryLimit = None
limit = None

MODINFO = { "Author": "\"Patch_R\" find me in BCfiles",
            "Version": "1.0",
            "License": "Feel free, to include my script in your mod, yust keep me informed and noted",
            "Description": "Enables transfering power to the batterys and backup..."
            }

def init():	
	global pBrexMenu, pBatteryButton, BCS, pBackupButton, pPowerTransfer, pPlayer
	import Libs.LibEngineering
	if not Libs.LibEngineering.CheckActiveMutator("Patch_R: Routing power to backups"):
		return
	if not pPlayer:
		return
	pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
	try:
		import Libs.BCSTNGLib
		BCS = 1
		pModule = __import__("Custom.UnifiedMainMenu.ConfigModules.Options.BCSTheBeginning")
		pOption = pModule.EngineeringOption
		EngineeringOption = int(pOption)
	except:
		EngineeringOption = 0
		BCS = 0

	if EngineeringOption == 1:
		pBrexMenu = Libs.BCSTNGLib.CreateEngineerMenu("Core power transfer", "Engineer")
		pBatteryButton = Libs.BCSTNGLib.CreateButton("Core power to battery", "Engineer", __name__ + ".Battery", "Core power transfer")
		pBackupButton = Libs.BCSTNGLib.CreateButton("Core power to backup", "Engineer", __name__ + ".Backup", "Core power transfer")
	else:
		import Libs.LibEngineering
		pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
		pPowerTransfer = App.STMenu_CreateW(App.TGString("Core power transfer"))
		pBrexMenu.PrependChild(pPowerTransfer)
		pBatteryButton = Libs.LibEngineering.CreateMenuButton("Core power to battery", "Engineer", __name__ + ".Battery", 0, pPowerTransfer)
		pBackupButton = Libs.LibEngineering.CreateMenuButton("Core power to backup", "Engineer", __name__ + ".Backup", 0, pPowerTransfer)

def Battery(pObject, pEvent):
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Transfer", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)
	
def Backup(pObject, pEvent):
	EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BackupTransfer", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)

def disblaebuttons(pObject, pEvent):
	global pPowerTransfer ,BCS
	pBatteryButton.SetDisabled()
	pBackupButton.SetDisabled()
	pBrexMenu.SetDisabled()
	if not BCS == 1:
		pPowerTransfer.SetDisabled()
	pSound = App.TGSound_Create("sfx/Bridge/Crew/Engineering/ge0140.mp3", "EPE", 0)
	pSound.SetSFX(0)
	pSound.SetInterface(1)
	App.g_kSoundManager.PlaySound("EPE")

def enablaebuttons(pObject, pEvent):
	global pPowerTransfer, BCS
	pBatteryButton.SetEnabled()
	pBackupButton.SetEnabled()
	pBrexMenu.SetEnabled()
	if not BCS == 1:
		pPowerTransfer.SetDisabled()

def Transfer(pObject, pEvent):
	global poweroutold, backupold, MainBatteryPower, limit
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	if pPower:
		powerout = pPower.GetPowerOutput()
		poweroutold = powerout
		limit = pPower.GetMainBatteryLimit()
		MainBatteryPower = pPower.GetMainBatteryPower()
		if MainBatteryPower < (limit * 0.95):
			Boost(pObject, pEvent)
			pPower.GetProperty().SetPowerOutput(powerout * 0.01)
			disblaebuttons(pObject, pEvent)
	else:
		return

def BackupTransfer(pObject, pEvent):
	global poweroutold, ReserveBatteryPower, ReserveBatteryLimit
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	if pPower:
		powerout = pPower.GetPowerOutput()
		poweroutold = powerout
		limit = pPower.GetMainBatteryLimit()
		ReserveBatteryPower = pPower.GetBackupBatteryPower()
		ReserveBatteryLimit = pPower.GetBackupBatteryLimit()
		if ReserveBatteryPower < (ReserveBatteryLimit * 0.95):
			BackupBoost(pObject, pEvent)
			pPower.GetProperty().SetPowerOutput(powerout * 0.01)
			disblaebuttons(pObject, pEvent)
	else:
		return

def BackupBoost(pObject, pEvent):
	global ReserveBatteryPower, ReserveBatteryLimit
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	if ReserveBatteryPower < (ReserveBatteryLimit * 0.95):
		pPower.SetBackupBatteryPower(ReserveBatteryPower * 1.05)
		ReserveBatteryPower = pPower.GetBackupBatteryPower()
		EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".BackupCheck", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)
		
def Boost(pObject, pEvent):
	global MainBatteryPower, limit
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	if MainBatteryPower < (limit * 0.95):
		pPower.SetMainBatteryPower(MainBatteryPower * 1.05)
		MainBatteryPower = pPower.GetMainBatteryPower()
		EnableTimer = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".Check", App.g_kUtopiaModule.GetGameTime() + 1, 0, 0)
		
def Check(pObject, pEvent):
	global poweroutold, MainBatteryPower, limit
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	if MainBatteryPower < (limit * 0.95):
		Boost(pObject, pEvent)
	else:
		pPower.GetProperty().SetPowerOutput(poweroutold)
		enablaebuttons(pObject, pEvent)

def BackupCheck(pObject, pEvent):
	global poweroutold, ReserveBatteryPower, ReserveBatteryLimit
	pPlayer = MissionLib.GetPlayer()
	pPower = pPlayer.GetPowerSubsystem()
	if ReserveBatteryPower < (ReserveBatteryLimit * 0.95):
		BackupBoost(pObject, pEvent)
	else:
		pPower.GetProperty().SetPowerOutput(poweroutold)
		enablaebuttons(pObject, pEvent)